package nl.amis.ticketservice;

import java.text.SimpleDateFormat;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;

import java.util.Date;
import java.util.HashMap;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.faces.model.SelectItemGroup;

import oracle.adf.view.faces.component.core.input.CoreInputText;
import oracle.adf.view.faces.component.core.input.CoreSelectOneListbox;
import oracle.adf.view.faces.component.core.input.CoreSelectOneRadio;


public class BoxOfficeBean {
    private BookingBean bookingBean;
    private Collection<Show> shows = new ArrayList<Show>(20);
    private CoreSelectOneListbox selectOneShowList;

    private Date getDate(String dateString) {
        Date d = new Date();
        try {
          SimpleDateFormat sdf = new SimpleDateFormat("d-M-yyyy");
          d = sdf.parse(dateString);
        }
        catch (Exception e) { System.out.println("");}
        
        return d;
        
    }

    public BoxOfficeBean() {
      // initiate the Shows Collection 
      // in a real application this would of course be done using a backend
      // service that provides Show details from a database or webservice
      shows.add(new Show("Carmen","ope",true,43.5,getDate("15-9-2005"),getDate("23-11-2006"),5, "http://www.operafiesole.it/immagini/PosterCarmenPt.JPG"));
      shows.add(new Show("La Nozze di Figaro","ope",true,61.0,getDate("1-7-2006"),getDate("13-3-2007"),8,"http://www.ctgrandopera.org/images/figaro.jpg"));
      shows.add(new Show("The Woman in Black","pla",false,18.5,getDate("5-5-2006"),getDate("17-12-2006"),12,"http://www.oldh.net/images/theatre/wominblack.jpg"));
      shows.add(new Show("The Mouse Trap","pla",false,13.5,getDate("23-1-2007"),getDate("28-5-2007"),25,"http://www.bakertheater.org/images/season05/mouse.jpg"));
      shows.add(new Show("The Nutcracker","bal",true,33.5,getDate("1-9-2006"),getDate("17-11-2006"),8,"http://www.durbanet.co.za/darts/1999/03/pics/nutcracker-267x400.jpg"));
      shows.add(new Show("Don Quixote","bal",false,27.5,getDate("15-11-2007"),getDate("31-12-2007"),6,"http://www.biblioteca-spinea.it/images/don_quixote_balletto.jpg"));
      shows.add(new Show("The Lion King","mus",false,30,getDate("14-4-2006"),getDate("23-10-2007"),4,"http://fan.crush-me.net/lionking/lionlay1.jpg"));
      shows.add(new Show("Joseph and the Amazing Technicolor Dreamcoat","mus",false,25.0,getDate("15-8-2006"),getDate("1-12-2006"),7,"http://www.rcenter.org/Images/PerformingArts/Joseph.gif"));
    }
    
    public SelectItem[] getShowSelectItems() {
       String lastCategory="";
       SelectItem[] items = new SelectItem[ shows.size()+10]; 
       int i=0;
       for (Show show:this.shows) {
          if (fitsCategory(show.getCategory(), this.bookingBean.getCategories()))
            items[i++] = new SelectItem(show,show.getTitle());
       }
       return items;
    }
    
    public Collection<Show> getShows() {
      return shows;
        
    }

    public void setBookingBean(BookingBean bookingBean) {
        this.bookingBean = bookingBean;
    }

    public BookingBean getBookingBean() {
        return bookingBean;
    }
    
    public Show getShow() {
        return bookingBean.getShow();
    }
    public static void main(String[] args) throws Exception{
        Date d = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("d-M-yyyy");
        d = sdf.parse("1-12-2006");
        System.out.println(d);
    }


    public void showChangeListener(ValueChangeEvent valueChangeEvent) {
        // Add event code here...
        System.out.println(valueChangeEvent.getNewValue());
    }

    private boolean fitsCategory(String cat, String[] cats) {
      if (cats!=null) {
        Collection<String> labels = Arrays.asList(cats);        
        return labels.contains(cat);
      }
      else return false;
    }

    public void validatePartyCount(FacesContext facesContext, 
                                   UIComponent uiComponent, Object object) {
        Object submittedShow =  getSelectOneShowList().getValue();                                 
        if (submittedShow!=null) {
        Short maxParty = ((Show)submittedShow).getMaxParty();
        if ((Integer)object> maxParty ) {
          ((CoreInputText)uiComponent).setValid(false);
          FacesMessage message = new FacesMessage("The maximum of tickets for this show is unfortunately limited to "+maxParty+"!");
          facesContext.addMessage(uiComponent.getClientId(facesContext), message);    
           }
        }  
           }

    public void setSelectOneShowList(CoreSelectOneListbox selectOneShowList) {
        this.selectOneShowList = selectOneShowList;
    }

    public CoreSelectOneListbox getSelectOneShowList() {
        return selectOneShowList;
    }
}
